diff -Naur tomato/release/src/router/pppd/pppd/plugins/radius/radiusclient.h tomato121/release/src/router/pppd/pppd/plugins/radius/radiusclient.h
--- tomato/release/src/router/pppd/pppd/plugins/radius/radiusclient.h	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/pppd/plugins/radius/radiusclient.h	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,455 @@
+/*
+ * $Id: radiusclient.h,v 1.1 2004/11/14 07:26:26 paulus Exp $
+ *
+ * Copyright (C) 1995,1996,1997,1998 Lars Fenneberg
+ *
+ * Copyright 1992 Livingston Enterprises, Inc.
+ *
+ * Copyright 1992,1993, 1994,1995 The Regents of the University of Michigan
+ * and Merit Network, Inc. All Rights Reserved
+ *
+ * See the file COPYRIGHT for the respective terms and conditions.
+ * If the file is missing contact me at lf@elemental.net
+ * and I'll send you a copy.
+ *
+ */
+
+#ifndef RADIUSCLIENT_H
+#define RADIUSCLIENT_H
+
+#include	<sys/types.h>
+#include	<stdio.h>
+#include	<time.h>
+#include "pppd.h"
+
+#ifndef _UINT4_T
+/* This works for all machines that Linux runs on... */
+typedef unsigned int UINT4;
+typedef int          INT4;
+#endif
+
+#define AUTH_VECTOR_LEN		16
+#define AUTH_PASS_LEN		(3 * 16) /* multiple of 16 */
+#define AUTH_ID_LEN		64
+#define AUTH_STRING_LEN		128	 /* maximum of 253 */
+
+#define	BUFFER_LEN		8192
+
+#define NAME_LENGTH		32
+#define	GETSTR_LENGTH		128	/* must be bigger than AUTH_PASS_LEN */
+
+/* codes for radius_buildreq, radius_getport, etc. */
+#define AUTH			0
+#define ACCT			1
+
+/* defines for config.c */
+
+#define SERVER_MAX 8
+
+#define AUTH_LOCAL_FST	(1<<0)
+#define AUTH_RADIUS_FST (1<<1)
+#define AUTH_LOCAL_SND  (1<<2)
+#define AUTH_RADIUS_SND (1<<3)
+
+typedef struct server {
+	int max;
+	char *name[SERVER_MAX];
+	unsigned short port[SERVER_MAX];
+} SERVER;
+
+typedef struct pw_auth_hdr
+{
+	u_char          code;
+	u_char          id;
+	u_short         length;
+	u_char          vector[AUTH_VECTOR_LEN];
+	u_char          data[2];
+} AUTH_HDR;
+
+#define AUTH_HDR_LEN			20
+#define MAX_SECRET_LENGTH		(3 * 16) /* MUST be multiple of 16 */
+#define CHAP_VALUE_LENGTH		16
+
+#define PW_AUTH_UDP_PORT		1812
+#define PW_ACCT_UDP_PORT		1813
+
+#define PW_TYPE_STRING			0
+#define PW_TYPE_INTEGER			1
+#define PW_TYPE_IPADDR			2
+#define PW_TYPE_DATE			3
+
+/* standard RADIUS codes */
+
+#define	PW_ACCESS_REQUEST		1
+#define	PW_ACCESS_ACCEPT		2
+#define	PW_ACCESS_REJECT		3
+#define	PW_ACCOUNTING_REQUEST		4
+#define	PW_ACCOUNTING_RESPONSE		5
+#define	PW_ACCOUNTING_STATUS		6
+#define	PW_PASSWORD_REQUEST		7
+#define	PW_PASSWORD_ACK			8
+#define	PW_PASSWORD_REJECT		9
+#define	PW_ACCOUNTING_MESSAGE		10
+#define	PW_ACCESS_CHALLENGE		11
+#define	PW_STATUS_SERVER		12
+#define	PW_STATUS_CLIENT		13
+
+
+/* standard RADIUS attribute-value pairs */
+
+#define	PW_USER_NAME			1	/* string */
+#define	PW_USER_PASSWORD		2	/* string */
+#define	PW_CHAP_PASSWORD		3	/* string */
+#define	PW_NAS_IP_ADDRESS		4	/* ipaddr */
+#define	PW_NAS_PORT			5	/* integer */
+#define	PW_SERVICE_TYPE			6	/* integer */
+#define	PW_FRAMED_PROTOCOL		7	/* integer */
+#define	PW_FRAMED_IP_ADDRESS		8	/* ipaddr */
+#define	PW_FRAMED_IP_NETMASK		9	/* ipaddr */
+#define	PW_FRAMED_ROUTING		10	/* integer */
+#define	PW_FILTER_ID		        11	/* string */
+#define	PW_FRAMED_MTU			12	/* integer */
+#define	PW_FRAMED_COMPRESSION		13	/* integer */
+#define	PW_LOGIN_IP_HOST		14	/* ipaddr */
+#define	PW_LOGIN_SERVICE		15	/* integer */
+#define	PW_LOGIN_PORT			16	/* integer */
+#define	PW_OLD_PASSWORD			17	/* string */ /* deprecated */
+#define	PW_REPLY_MESSAGE		18	/* string */
+#define	PW_LOGIN_CALLBACK_NUMBER	19	/* string */
+#define	PW_FRAMED_CALLBACK_ID		20	/* string */
+#define	PW_EXPIRATION			21	/* date */ /* deprecated */
+#define	PW_FRAMED_ROUTE			22	/* string */
+#define	PW_FRAMED_IPX_NETWORK		23	/* integer */
+#define	PW_STATE			24	/* string */
+#define	PW_CLASS			25	/* string */
+#define	PW_VENDOR_SPECIFIC		26	/* string */
+#define	PW_SESSION_TIMEOUT		27	/* integer */
+#define	PW_IDLE_TIMEOUT			28	/* integer */
+#define	PW_TERMINATION_ACTION		29	/* integer */
+#define	PW_CALLED_STATION_ID            30      /* string */
+#define	PW_CALLING_STATION_ID           31      /* string */
+#define	PW_NAS_IDENTIFIER		32	/* string */
+#define	PW_PROXY_STATE			33	/* string */
+#define	PW_LOGIN_LAT_SERVICE		34	/* string */
+#define	PW_LOGIN_LAT_NODE		35	/* string */
+#define	PW_LOGIN_LAT_GROUP		36	/* string */
+#define	PW_FRAMED_APPLETALK_LINK	37	/* integer */
+#define	PW_FRAMED_APPLETALK_NETWORK	38	/* integer */
+#define	PW_FRAMED_APPLETALK_ZONE	39	/* string */
+#define	PW_CHAP_CHALLENGE               60      /* string */
+#define	PW_NAS_PORT_TYPE                61      /* integer */
+#define	PW_PORT_LIMIT                   62      /* integer */
+#define PW_LOGIN_LAT_PORT               63      /* string */
+
+/* Vendor RADIUS attribute-value pairs */
+#define PW_MS_CHAP_CHALLENGE		11	/* string */
+#define PW_MS_CHAP_RESPONSE		1	/* string */
+#define PW_MS_CHAP2_RESPONSE		25	/* string */
+#define PW_MS_CHAP2_SUCCESS		26	/* string */
+#define PW_MS_MPPE_ENCRYPTION_POLICY	7	/* string */
+#define PW_MS_MPPE_ENCRYPTION_TYPE	8	/* string */
+#define PW_MS_MPPE_ENCRYPTION_TYPES PW_MS_MPPE_ENCRYPTION_TYPE
+#define PW_MS_CHAP_MPPE_KEYS		12	/* string */
+#define PW_MS_MPPE_SEND_KEY		16	/* string */
+#define PW_MS_MPPE_RECV_KEY		17	/* string */
+
+/*	Accounting */
+
+#define	PW_ACCT_STATUS_TYPE		40	/* integer */
+#define	PW_ACCT_DELAY_TIME		41	/* integer */
+#define	PW_ACCT_INPUT_OCTETS		42	/* integer */
+#define	PW_ACCT_OUTPUT_OCTETS		43	/* integer */
+#define	PW_ACCT_SESSION_ID		44	/* string */
+#define	PW_ACCT_AUTHENTIC		45	/* integer */
+#define	PW_ACCT_SESSION_TIME		46	/* integer */
+#define	PW_ACCT_INPUT_PACKETS		47	/* integer */
+#define	PW_ACCT_OUTPUT_PACKETS		48	/* integer */
+#define PW_ACCT_TERMINATE_CAUSE		49	/* integer */
+#define PW_ACCT_MULTI_SESSION_ID	50	/* string */
+#define PW_ACCT_LINK_COUNT		51	/* integer */
+
+/* From RFC 2869 */
+#define PW_ACCT_INTERIM_INTERVAL        85	/* integer */
+
+/*	Merit Experimental Extensions */
+
+#define PW_USER_ID                      222     /* string */
+#define PW_USER_REALM                   223     /* string */
+
+
+/*      Session limits */
+#define PW_SESSION_OCTETS_LIMIT		227    /* integer */
+#define PW_OCTETS_DIRECTION		228    /* integer */
+
+/*	Integer Translations */
+
+/*	SERVICE TYPES	*/
+
+#define	PW_LOGIN			1
+#define	PW_FRAMED			2
+#define	PW_CALLBACK_LOGIN		3
+#define	PW_CALLBACK_FRAMED		4
+#define	PW_OUTBOUND			5
+#define	PW_ADMINISTRATIVE		6
+#define PW_NAS_PROMPT                   7
+#define PW_AUTHENTICATE_ONLY		8
+#define PW_CALLBACK_NAS_PROMPT          9
+
+/*	FRAMED PROTOCOLS	*/
+
+#define	PW_PPP				1
+#define	PW_SLIP				2
+#define PW_ARA                          3
+#define PW_GANDALF                      4
+#define PW_XYLOGICS                     5
+
+/*	FRAMED ROUTING VALUES	*/
+
+#define	PW_NONE				0
+#define	PW_BROADCAST			1
+#define	PW_LISTEN			2
+#define	PW_BROADCAST_LISTEN		3
+
+/*	FRAMED COMPRESSION TYPES	*/
+
+#define	PW_VAN_JACOBSON_TCP_IP		1
+#define	PW_IPX_HEADER_COMPRESSION	2
+
+/*	LOGIN SERVICES	*/
+
+#define PW_TELNET                       0
+#define PW_RLOGIN                       1
+#define PW_TCP_CLEAR                    2
+#define PW_PORTMASTER                   3
+#define PW_LAT                          4
+#define PW_X25_PAD                      5
+#define PW_X25_T3POS                    6
+
+/*	TERMINATION ACTIONS	*/
+
+#define	PW_DEFAULT			0
+#define	PW_RADIUS_REQUEST		1
+
+/*	PROHIBIT PROTOCOL  */
+
+#define PW_DUMB		0	/* 1 and 2 are defined in FRAMED PROTOCOLS */
+#define PW_AUTH_ONLY	3
+#define PW_ALL		255
+
+/*	ACCOUNTING STATUS TYPES    */
+
+#define PW_STATUS_START		1
+#define PW_STATUS_STOP		2
+#define PW_STATUS_ALIVE		3
+#define PW_STATUS_MODEM_START	4
+#define PW_STATUS_MODEM_STOP	5
+#define PW_STATUS_CANCEL	6
+#define PW_ACCOUNTING_ON	7
+#define PW_ACCOUNTING_OFF	8
+
+/*      ACCOUNTING TERMINATION CAUSES   */
+
+#define PW_USER_REQUEST         1
+#define PW_LOST_CARRIER         2
+#define PW_LOST_SERVICE         3
+#define PW_ACCT_IDLE_TIMEOUT    4
+#define PW_ACCT_SESSION_TIMEOUT 5
+#define PW_ADMIN_RESET          6
+#define PW_ADMIN_REBOOT         7
+#define PW_PORT_ERROR           8
+#define PW_NAS_ERROR            9
+#define PW_NAS_REQUEST          10
+#define PW_NAS_REBOOT           11
+#define PW_PORT_UNNEEDED        12
+#define PW_PORT_PREEMPTED       13
+#define PW_PORT_SUSPENDED       14
+#define PW_SERVICE_UNAVAILABLE  15
+#define PW_CALLBACK             16
+#define PW_USER_ERROR           17
+#define PW_HOST_REQUEST         18
+
+/*     NAS PORT TYPES    */
+
+#define PW_ASYNC		0
+#define PW_SYNC			1
+#define PW_ISDN_SYNC		2
+#define PW_ISDN_SYNC_V120	3
+#define PW_ISDN_SYNC_V110	4
+#define PW_VIRTUAL		5
+
+/*	   AUTHENTIC TYPES */
+#define PW_RADIUS	1
+#define PW_LOCAL	2
+#define PW_REMOTE	3
+
+/*    Session-Octets-Limit    */
+#define PW_OCTETS_DIRECTION_SUM	0
+#define PW_OCTETS_DIRECTION_IN	1
+#define PW_OCTETS_DIRECTION_OUT	2
+#define PW_OCTETS_DIRECTION_MAX	3
+
+
+/* Vendor codes */
+#define VENDOR_NONE     (-1)
+#define VENDOR_MICROSOFT	311
+
+/* Server data structures */
+
+typedef struct dict_attr
+{
+	char              name[NAME_LENGTH + 1];	/* attribute name */
+	int               value;			/* attribute index */
+	int               type;				/* string, int, etc. */
+	int               vendorcode;                   /* vendor code */
+	struct dict_attr *next;
+} DICT_ATTR;
+
+typedef struct dict_value
+{
+	char               attrname[NAME_LENGTH +1];
+	char               name[NAME_LENGTH + 1];
+	int                value;
+	struct dict_value *next;
+} DICT_VALUE;
+
+typedef struct vendor_dict
+{
+    char vendorname[NAME_LENGTH + 1];
+    int vendorcode;
+    DICT_ATTR *attributes;
+    struct vendor_dict *next;
+} VENDOR_DICT;
+
+typedef struct value_pair
+{
+	char               name[NAME_LENGTH + 1];
+	int                attribute;
+	int                vendorcode;
+	int                type;
+	UINT4              lvalue;
+	u_char             strvalue[AUTH_STRING_LEN + 1];
+	struct value_pair *next;
+} VALUE_PAIR;
+
+/* don't change this, as it has to be the same as in the Merit radiusd code */
+#define MGMT_POLL_SECRET	"Hardlyasecret"
+
+/*	Define return codes from "SendServer" utility */
+
+#define BADRESP_RC	-2
+#define ERROR_RC	-1
+#define OK_RC		0
+#define TIMEOUT_RC	1
+
+typedef struct send_data /* Used to pass information to sendserver() function */
+{
+	u_char          code;		/* RADIUS packet code */
+	u_char          seq_nbr;	/* Packet sequence number */
+	char           *server;		/* Name/addrress of RADIUS server */
+	int             svc_port;	/* RADIUS protocol destination port */
+	int             timeout;	/* Session timeout in seconds */
+	int		retries;
+	VALUE_PAIR     *send_pairs;     /* More a/v pairs to send */
+	VALUE_PAIR     *receive_pairs;  /* Where to place received a/v pairs */
+} SEND_DATA;
+
+typedef struct request_info
+{
+	char		secret[MAX_SECRET_LENGTH + 1];
+	u_char		request_vector[AUTH_VECTOR_LEN];
+} REQUEST_INFO;
+
+#ifndef MIN
+#define MIN(a, b)     ((a) < (b) ? (a) : (b))
+#endif
+#ifndef MAX
+#define MAX(a, b)     ((a) > (b) ? (a) : (b))
+#endif
+
+#ifndef PATH_MAX
+#define PATH_MAX	1024
+#endif
+
+typedef struct env
+{
+	int maxsize, size;
+	char **env;
+} ENV;
+
+#define ENV_SIZE	128
+
+/*	Function prototypes	*/
+
+/*	avpair.c		*/
+
+VALUE_PAIR *rc_avpair_add __P((VALUE_PAIR **, int, void *, int, int));
+int rc_avpair_assign __P((VALUE_PAIR *, void *, int));
+VALUE_PAIR *rc_avpair_new __P((int, void *, int, int));
+VALUE_PAIR *rc_avpair_gen __P((AUTH_HDR *));
+VALUE_PAIR *rc_avpair_get __P((VALUE_PAIR *, UINT4));
+VALUE_PAIR *rc_avpair_copy __P((VALUE_PAIR *));
+void rc_avpair_insert __P((VALUE_PAIR **, VALUE_PAIR *, VALUE_PAIR *));
+void rc_avpair_free __P((VALUE_PAIR *));
+int rc_avpair_parse __P((char *, VALUE_PAIR **));
+int rc_avpair_tostr __P((VALUE_PAIR *, char *, int, char *, int));
+VALUE_PAIR *rc_avpair_readin __P((FILE *));
+
+/*	buildreq.c		*/
+
+void rc_buildreq __P((SEND_DATA *, int, char *, unsigned short, int, int));
+unsigned char rc_get_seqnbr __P((void));
+int rc_auth __P((UINT4, VALUE_PAIR *, VALUE_PAIR **, char *, REQUEST_INFO *));
+int rc_auth_using_server __P((SERVER *, UINT4, VALUE_PAIR *, VALUE_PAIR **,
+			      char *, REQUEST_INFO *));
+int rc_auth_proxy __P((VALUE_PAIR *, VALUE_PAIR **, char *));
+int rc_acct __P((UINT4, VALUE_PAIR *));
+int rc_acct_using_server __P((SERVER *, UINT4, VALUE_PAIR *));
+int rc_acct_proxy __P((VALUE_PAIR *));
+int rc_check __P((char *, unsigned short, char *));
+
+/*	clientid.c		*/
+
+int rc_read_mapfile __P((char *));
+UINT4 rc_map2id __P((char *));
+
+/*	config.c		*/
+
+int rc_read_config __P((char *));
+char *rc_conf_str __P((char *));
+int rc_conf_int __P((char *));
+SERVER *rc_conf_srv __P((char *));
+int rc_find_server __P((char *, UINT4 *, char *));
+
+/*	dict.c			*/
+
+int rc_read_dictionary __P((char *));
+DICT_ATTR *rc_dict_getattr __P((int, int));
+DICT_ATTR *rc_dict_findattr __P((char *));
+DICT_VALUE *rc_dict_findval __P((char *));
+DICT_VALUE * rc_dict_getval __P((UINT4, char *));
+VENDOR_DICT * rc_dict_findvendor __P((char *));
+VENDOR_DICT * rc_dict_getvendor __P((int));
+
+/*	ip_util.c		*/
+
+UINT4 rc_get_ipaddr __P((char *));
+int rc_good_ipaddr __P((char *));
+const char *rc_ip_hostname __P((UINT4));
+UINT4 rc_own_ipaddress __P((void));
+
+
+/*	sendserver.c		*/
+
+int rc_send_server __P((SEND_DATA *, char *, REQUEST_INFO *));
+
+/*	util.c			*/
+
+void rc_str2tm __P((char *, struct tm *));
+char *rc_mksid __P((void));
+void rc_mdelay __P((int));
+
+/* md5.c			*/
+
+void rc_md5_calc __P((unsigned char *, unsigned char *, unsigned int));
+
+#endif /* RADIUSCLIENT_H */
diff -Naur tomato/release/src/router/pppd/pppd/plugins/radius/radrealms.c tomato121/release/src/router/pppd/pppd/plugins/radius/radrealms.c
--- tomato/release/src/router/pppd/pppd/plugins/radius/radrealms.c	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/pppd/plugins/radius/radrealms.c	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,147 @@
+/*
+*
+* radrealms.c
+*
+* A pppd plugin which is stacked on top of radius.so.  This plugin
+* allows selection of alternate set of servers based on the user's realm.
+*
+* Author: Ben McKeegan  ben@netservers.co.uk
+*
+* Copyright (C) 2002 Netservers
+*
+* This plugin may be distributed according to the terms of the GNU
+* General Public License, version 2 or (at your option) any later version.
+*
+*/
+
+static char const RCSID[] =
+    "$Id: radrealms.c,v 1.2 2004/11/14 07:26:26 paulus Exp $";
+
+#include "pppd.h"
+#include "radiusclient.h"
+#include <stdio.h>
+#include <string.h>
+#include <stdlib.h>
+
+char pppd_version[] = VERSION;
+
+char radrealms_config[MAXPATHLEN] = "/etc/radiusclient/realms";
+
+static option_t Options[] = {
+    { "realms-config-file", o_string, &radrealms_config },
+    { NULL }
+};
+
+extern void (*radius_pre_auth_hook)(char const *user,
+				    SERVER **authserver,
+				    SERVER **acctserver);
+
+static void
+lookup_realm(char const *user,
+	     SERVER **authserver,
+	     SERVER **acctserver)
+{
+    char *realm;
+    FILE *fd;
+    SERVER *accts, *auths, *s;
+    char buffer[512], *p;
+    int line = 0;
+    
+    auths = (SERVER *) malloc(sizeof(SERVER));
+    auths->max = 0;
+    accts = (SERVER *) malloc(sizeof(SERVER));
+    accts->max = 0;
+    
+    realm = strrchr(user, '@');
+    
+    if (realm) {
+	info("Looking up servers for realm '%s'", realm);
+    } else {
+	info("Looking up servers for DEFAULT realm");
+    }
+    if (realm) {
+	if (*(++realm) == '\0') {
+	    realm = NULL;
+	}
+    }
+    
+    if ((fd = fopen(radrealms_config, "r")) == NULL) {
+	option_error("cannot open %s", radrealms_config);
+	return;
+    } 
+    info("Reading %s", radrealms_config);
+    
+    while ((fgets(buffer, sizeof(buffer), fd) != NULL)) {
+	line++;
+
+	if ((*buffer == '\n') || (*buffer == '#') || (*buffer == '\0'))
+	    continue;
+
+	buffer[strlen(buffer)-1] = '\0';
+
+	p = strtok(buffer, "\t ");
+
+	if (p == NULL || (strcmp(p, "authserver") !=0
+	    && strcmp(p, "acctserver"))) {
+	    fclose(fd);
+	    option_error("%s: invalid line %d: %s", radrealms_config,
+			 line, buffer);
+	    return;
+	}
+	info("Parsing '%s' entry:", p);
+	s = auths;
+	if (p[1] == 'c') {
+	    s = accts;
+	}
+	if (s->max >= SERVER_MAX)
+	    continue;
+
+	if ((p = strtok(NULL, "\t ")) == NULL) {
+	    fclose(fd);
+	    option_error("%s: realm name missing on line %d: %s",
+			 radrealms_config, line, buffer);
+	    return;
+	}
+
+	if ((realm != NULL && strcmp(p, realm) == 0) ||
+	    (realm == NULL && strcmp(p, "DEFAULT") == 0) ) {
+	    info(" - Matched realm %s", p);
+	    if ((p = strtok(NULL, ":")) == NULL) {
+		fclose(fd);
+		option_error("%s: server address missing on line %d: %s",
+			     radrealms_config, line, buffer);
+		return;
+	    }
+	    s->name[s->max] = strdup(p);
+	    info(" - Address is '%s'",p);
+	    if ((p = strtok(NULL, "\t ")) == NULL) {
+		fclose(fd);
+		option_error("%s: server port missing on line %d:  %s",
+			     radrealms_config, line, buffer);
+		return;
+	    }
+	    s->port[s->max] = atoi(p);
+	    info(" - Port is '%d'", s->port[s->max]);
+	    s->max++;
+	} else 
+	    info(" - Skipping realm '%s'", p);
+    }
+    fclose(fd);
+
+    if (accts->max)
+	*acctserver = accts;
+
+    if (auths->max)
+	*authserver = auths;
+
+    return;
+}
+
+void
+plugin_init(void)
+{
+    radius_pre_auth_hook = lookup_realm;
+
+    add_options(Options);
+    info("RADIUS Realms plugin initialized.");
+}
diff -Naur tomato/release/src/router/pppd/pppd/plugins/radius/sendserver.c tomato121/release/src/router/pppd/pppd/plugins/radius/sendserver.c
--- tomato/release/src/router/pppd/pppd/plugins/radius/sendserver.c	1970-01-01 10:00:00.000000000 +1000
+++ tomato121/release/src/router/pppd/pppd/plugins/radius/sendserver.c	2008-04-22 21:44:05.000000000 +1000
@@ -0,0 +1,520 @@
+/*
+ * $Id: sendserver.c,v 1.1 2004/11/14 07:26:26 paulus Exp $
+ *
+ * Copyright (C) 1995,1996,1997 Lars Fenneberg
+ *
+ * Copyright 1992 Livingston Enterprises, Inc.
+ *
+ * Copyright 1992,1993, 1994,1995 The Regents of the University of Michigan
+ * and Merit Network, Inc. All Rights Reserved
+ *
+ * See the file COPYRIGHT for the respective terms and conditions.
+ * If the file is missing contact me at lf@elemental.net
+ * and I'll send you a copy.
+ *
+ */
+
+#include <includes.h>
+#include <radiusclient.h>
+#include <pathnames.h>
+
+static void rc_random_vector (unsigned char *);
+static int rc_check_reply (AUTH_HDR *, int, char *, unsigned char *, unsigned char);
+
+/*
+ * Function: rc_pack_list
+ *
+ * Purpose: Packs an attribute value pair list into a buffer.
+ *
+ * Returns: Number of octets packed.
+ *
+ */
+
+static int rc_pack_list (VALUE_PAIR *vp, char *secret, AUTH_HDR *auth)
+{
+    int             length, i, pc, secretlen, padded_length;
+    int             total_length = 0;
+    UINT4           lvalue;
+    unsigned char   passbuf[MAX(AUTH_PASS_LEN, CHAP_VALUE_LENGTH)];
+    unsigned char   md5buf[256];
+    unsigned char   *buf, *vector, *lenptr;
+
+    buf = auth->data;
+
+    while (vp != (VALUE_PAIR *) NULL)
+	{
+
+	    if (vp->vendorcode != VENDOR_NONE) {
+		*buf++ = PW_VENDOR_SPECIFIC;
+
+		/* Place-holder for where to put length */
+		lenptr = buf++;
+
+		/* Insert vendor code */
+		*buf++ = 0;
+		*buf++ = (((unsigned int) vp->vendorcode) >> 16) & 255;
+		*buf++ = (((unsigned int) vp->vendorcode) >> 8) & 255;
+		*buf++ = ((unsigned int) vp->vendorcode) & 255;
+
+		/* Insert vendor-type */
+		*buf++ = vp->attribute;
+
+		/* Insert value */
+		switch(vp->type) {
+		case PW_TYPE_STRING:
+		    length = vp->lvalue;
+		    *lenptr = length + 8;
+		    *buf++ = length+2;
+		    memcpy(buf, vp->strvalue, (size_t) length);
+		    buf += length;
+		    total_length += length+8;
+		    break;
+		case PW_TYPE_INTEGER:
+		case PW_TYPE_IPADDR:
+		    length = sizeof(UINT4);
+		    *lenptr = length + 8;
+		    *buf++ = length+2;
+		    lvalue = htonl(vp->lvalue);
+		    memcpy(buf, (char *) &lvalue, sizeof(UINT4));
+		    buf += length;
+		    total_length += length+8;
+		    break;
+		default:
+		    break;
+		}
+	    } else {
+		*buf++ = vp->attribute;
+		switch (vp->attribute) {
+		case PW_USER_PASSWORD:
+
+		    /* Encrypt the password */
+
+		    /* Chop off password at AUTH_PASS_LEN */
+		    length = vp->lvalue;
+		    if (length > AUTH_PASS_LEN) length = AUTH_PASS_LEN;
+
+		    /* Calculate the padded length */
+		    padded_length = (length+(AUTH_VECTOR_LEN-1)) & ~(AUTH_VECTOR_LEN-1);
+
+		    /* Record the attribute length */
+		    *buf++ = padded_length + 2;
+
+		    /* Pad the password with zeros */
+		    memset ((char *) passbuf, '\0', AUTH_PASS_LEN);
+		    memcpy ((char *) passbuf, vp->strvalue, (size_t) length);
+
+		    secretlen = strlen (secret);
+		    vector = (char *)auth->vector;
+		    for(i = 0; i < padded_length; i += AUTH_VECTOR_LEN) {
+			/* Calculate the MD5 digest*/
+			strcpy ((char *) md5buf, secret);
+			memcpy ((char *) md5buf + secretlen, vector,
+				AUTH_VECTOR_LEN);
+			rc_md5_calc (buf, md5buf, secretlen + AUTH_VECTOR_LEN);
+
+			/* Remeber the start of the digest */
+			vector = buf;
+
+			/* Xor the password into the MD5 digest */
+			for (pc = i; pc < (i + AUTH_VECTOR_LEN); pc++) {
+			    *buf++ ^= passbuf[pc];
+			}
+		    }
+
+		    total_length += padded_length + 2;
+
+		    break;
+#if 0
+		case PW_CHAP_PASSWORD:
+
+		    *buf++ = CHAP_VALUE_LENGTH + 2;
+
+		    /* Encrypt the Password */
+		    length = vp->lvalue;
+		    if (length > CHAP_VALUE_LENGTH) {
+			length = CHAP_VALUE_LENGTH;
+		    }
+		    memset ((char *) passbuf, '\0', CHAP_VALUE_LENGTH);
+		    memcpy ((char *) passbuf, vp->strvalue, (size_t) length);
+
+		    /* Calculate the MD5 Digest */
+		    secretlen = strlen (secret);
+		    strcpy ((char *) md5buf, secret);
+		    memcpy ((char *) md5buf + secretlen, (char *) auth->vector,
+			    AUTH_VECTOR_LEN);
+		    rc_md5_calc (buf, md5buf, secretlen + AUTH_VECTOR_LEN);
+
+		    /* Xor the password into the MD5 digest */
+		    for (i = 0; i < CHAP_VALUE_LENGTH; i++) {
+			*buf++ ^= passbuf[i];
+		    }
+		    total_length += CHAP_VALUE_LENGTH + 2;
+
+		    break;
+#endif
+		default:
+		    switch (vp->type) {
+		    case PW_TYPE_STRING:
+			length = vp->lvalue;
+			*buf++ = length + 2;
+			memcpy (buf, vp->strvalue, (size_t) length);
+			buf += length;
+			total_length += length + 2;
+			break;
+
+		    case PW_TYPE_INTEGER:
+		    case PW_TYPE_IPADDR:
+			*buf++ = sizeof (UINT4) + 2;
+			lvalue = htonl (vp->lvalue);
+			memcpy (buf, (char *) &lvalue, sizeof (UINT4));
+			buf += sizeof (UINT4);
+			total_length += sizeof (UINT4) + 2;
+			break;
+
+		    default:
+			break;
+		    }
+		    break;
+		}
+	    }
+	    vp = vp->next;
+	}
+    return total_length;
+}
+
+/*
+ * Function: rc_send_server
+ *
+ * Purpose: send a request to a RADIUS server and wait for the reply
+ *
+ */
+
+int rc_send_server (SEND_DATA *data, char *msg, REQUEST_INFO *info)
+{
+	int             sockfd;
+	struct sockaddr salocal;
+	struct sockaddr saremote;
+	struct sockaddr_in *sin;
+	struct timeval  authtime;
+	fd_set          readfds;
+	AUTH_HDR       *auth, *recv_auth;
+	UINT4           auth_ipaddr;
+	char           *server_name;	/* Name of server to query */
+	int             salen;
+	int             result;
+	int             total_length;
+	int             length;
+	int             retry_max;
+	int		secretlen;
+	char            secret[MAX_SECRET_LENGTH + 1];
+	unsigned char   vector[AUTH_VECTOR_LEN];
+	char            recv_buffer[BUFFER_LEN];
+	char            send_buffer[BUFFER_LEN];
+	int		retries;
+	VALUE_PAIR	*vp;
+
+	server_name = data->server;
+	if (server_name == (char *) NULL || server_name[0] == '\0')
+		return (ERROR_RC);
+
+	if ((vp = rc_avpair_get(data->send_pairs, PW_SERVICE_TYPE)) && \
+	    (vp->lvalue == PW_ADMINISTRATIVE))
+	{
+		strcpy(secret, MGMT_POLL_SECRET);
+		if ((auth_ipaddr = rc_get_ipaddr(server_name)) == 0)
+			return (ERROR_RC);
+	}
+	else
+	{
+		if (rc_find_server (server_name, &auth_ipaddr, secret) != 0)
+		{
+			return (ERROR_RC);
+		}
+	}
+
+	sockfd = socket (AF_INET, SOCK_DGRAM, 0);
+	if (sockfd < 0)
+	{
+		memset (secret, '\0', sizeof (secret));
+		error("rc_send_server: socket: %s", strerror(errno));
+		return (ERROR_RC);
+	}
+
+	length = sizeof (salocal);
+	sin = (struct sockaddr_in *) & salocal;
+	memset ((char *) sin, '\0', (size_t) length);
+	sin->sin_family = AF_INET;
+	sin->sin_addr.s_addr = htonl(INADDR_ANY);
+	sin->sin_port = htons ((unsigned short) 0);
+	if (bind (sockfd, (struct sockaddr *) sin, length) < 0 ||
+		   getsockname (sockfd, (struct sockaddr *) sin, &length) < 0)
+	{
+		close (sockfd);
+		memset (secret, '\0', sizeof (secret));
+		error("rc_send_server: bind: %s: %m", server_name);
+		return (ERROR_RC);
+	}
+
+	retry_max = data->retries;	/* Max. numbers to try for reply */
+	retries = 0;			/* Init retry cnt for blocking call */
+
+	/* Build a request */
+	auth = (AUTH_HDR *) send_buffer;
+	auth->code = data->code;
+	auth->id = data->seq_nbr;
+
+	if (data->code == PW_ACCOUNTING_REQUEST)
+	{
+		total_length = rc_pack_list(data->send_pairs, secret, auth) + AUTH_HDR_LEN;
+
+		auth->length = htons ((unsigned short) total_length);
+
+		memset((char *) auth->vector, 0, AUTH_VECTOR_LEN);
+		secretlen = strlen (secret);
+		memcpy ((char *) auth + total_length, secret, secretlen);
+		rc_md5_calc (vector, (char *) auth, total_length + secretlen);
+		memcpy ((char *) auth->vector, (char *) vector, AUTH_VECTOR_LEN);
+	}
+	else
+	{
+		rc_random_vector (vector);
+		memcpy (auth->vector, vector, AUTH_VECTOR_LEN);
+
+		total_length = rc_pack_list(data->send_pairs, secret, auth) + AUTH_HDR_LEN;
+
+		auth->length = htons ((unsigned short) total_length);
+	}
+
+	sin = (struct sockaddr_in *) & saremote;
+	memset ((char *) sin, '\0', sizeof (saremote));
+	sin->sin_family = AF_INET;
+	sin->sin_addr.s_addr = htonl (auth_ipaddr);
+	sin->sin_port = htons ((unsigned short) data->svc_port);
+
+	for (;;)
+	{
+		sendto (sockfd, (char *) auth, (unsigned int) total_length, (int) 0,
+			(struct sockaddr *) sin, sizeof (struct sockaddr_in));
+
+		authtime.tv_usec = 0L;
+		authtime.tv_sec = (long) data->timeout;
+		FD_ZERO (&readfds);
+		FD_SET (sockfd, &readfds);
+		if (select (sockfd + 1, &readfds, NULL, NULL, &authtime) < 0)
+		{
+			if (errno == EINTR)
+				continue;
+			error("rc_send_server: select: %m");
+			memset (secret, '\0', sizeof (secret));
+			close (sockfd);
+			return (ERROR_RC);
+		}
+		if (FD_ISSET (sockfd, &readfds))
+			break;
+
+		/*
+		 * Timed out waiting for response.  Retry "retry_max" times
+		 * before giving up.  If retry_max = 0, don't retry at all.
+		 */
+		if (++retries >= retry_max)
+		{
+			error("rc_send_server: no reply from RADIUS server %s:%u",
+			      rc_ip_hostname (auth_ipaddr), data->svc_port);
+			close (sockfd);
+			memset (secret, '\0', sizeof (secret));
+			return (TIMEOUT_RC);
+		}
+	}
+	salen = sizeof (saremote);
+	length = recvfrom (sockfd, (char *) recv_buffer,
+			   (int) sizeof (recv_buffer),
+			   (int) 0, &saremote, &salen);
+
+	if (length <= 0)
+	{
+		error("rc_send_server: recvfrom: %s:%d: %m", server_name,\
+		      data->svc_port);
+		close (sockfd);
+		memset (secret, '\0', sizeof (secret));
+		return (ERROR_RC);
+	}
+
+	recv_auth = (AUTH_HDR *)recv_buffer;
+
+	result = rc_check_reply (recv_auth, BUFFER_LEN, secret, vector, data->seq_nbr);
+
+	data->receive_pairs = rc_avpair_gen(recv_auth);
+
+	close (sockfd);
+	if (info)
+	{
+		memcpy(info->secret, secret, sizeof(info->secret));
+		memcpy(info->request_vector, vector,
+		       sizeof(info->request_vector));
+	}
+	memset (secret, '\0', sizeof (secret));
+
+	if (result != OK_RC) return (result);
+
+	*msg = '\0';
+	vp = data->receive_pairs;
+	while (vp)
+	{
+		if ((vp = rc_avpair_get(vp, PW_REPLY_MESSAGE)))
+		{
+			strcat(msg, vp->strvalue);
+			strcat(msg, "\n");
+			vp = vp->next;
+		}
+	}
+
+	if ((recv_auth->code == PW_ACCESS_ACCEPT) ||
+		(recv_auth->code == PW_PASSWORD_ACK) ||
+		(recv_auth->code == PW_ACCOUNTING_RESPONSE))
+	{
+		result = OK_RC;
+	}
+	else
+	{
+		result = BADRESP_RC;
+	}
+
+	return (result);
+}
+
+/*
+ * Function: rc_check_reply
+ *
+ * Purpose: verify items in returned packet.
+ *
+ * Returns:	OK_RC       -- upon success,
+ *		BADRESP_RC  -- if anything looks funny.
+ *
+ */
+
+static int rc_check_reply (AUTH_HDR *auth, int bufferlen, char *secret,
+			   unsigned char *vector, unsigned char seq_nbr)
+{
+	int             secretlen;
+	int             totallen;
+	unsigned char   calc_digest[AUTH_VECTOR_LEN];
+	unsigned char   reply_digest[AUTH_VECTOR_LEN];
+
+	totallen = ntohs (auth->length);
+
+	secretlen = strlen (secret);
+
+	/* Do sanity checks on packet length */
+	if ((totallen < 20) || (totallen > 4096))
+	{
+		error("rc_check_reply: received RADIUS server response with invalid length");
+		return (BADRESP_RC);
+	}
+
+	/* Verify buffer space, should never trigger with current buffer size and check above */
+	if ((totallen + secretlen) > bufferlen)
+	{
+		error("rc_check_reply: not enough buffer space to verify RADIUS server response");
+		return (BADRESP_RC);
+	}
+	/* Verify that id (seq. number) matches what we sent */
+	if (auth->id != seq_nbr)
+	{
+		error("rc_check_reply: received non-matching id in RADIUS server response");
+		return (BADRESP_RC);
+	}
+
+	/* Verify the reply digest */
+	memcpy ((char *) reply_digest, (char *) auth->vector, AUTH_VECTOR_LEN);
+	memcpy ((char *) auth->vector, (char *) vector, AUTH_VECTOR_LEN);
+	memcpy ((char *) auth + totallen, secret, secretlen);
+	rc_md5_calc (calc_digest, (char *) auth, totallen + secretlen);
+
+#ifdef DIGEST_DEBUG
+	{
+		int i;
+
+		fputs("reply_digest: ", stderr);
+		for (i = 0; i < AUTH_VECTOR_LEN; i++)
+		{
+			fprintf(stderr,"%.2x ", (int) reply_digest[i]);
+		}
+		fputs("\ncalc_digest:  ", stderr);
+		for (i = 0; i < AUTH_VECTOR_LEN; i++)
+		{
+			fprintf(stderr,"%.2x ", (int) calc_digest[i]);
+		}
+		fputs("\n", stderr);
+	}
+#endif
+
+	if (memcmp ((char *) reply_digest, (char *) calc_digest,
+		    AUTH_VECTOR_LEN) != 0)
+	{
+#ifdef RADIUS_116
+		/* the original Livingston radiusd v1.16 seems to have
+		   a bug in digest calculation with accounting requests,
+		   authentication request are ok. i looked at the code
+		   but couldn't find any bugs. any help to get this
+		   kludge out are welcome. preferably i want to
+		   reproduce the calculation bug here to be compatible
+		   to stock Livingston radiusd v1.16.	-lf, 03/14/96
+		 */
+		if (auth->code == PW_ACCOUNTING_RESPONSE)
+			return (OK_RC);
+#endif
+		error("rc_check_reply: received invalid reply digest from RADIUS server");
+		return (BADRESP_RC);
+	}
+
+	return (OK_RC);
+
+}
+
+/*
+ * Function: rc_random_vector
+ *
+ * Purpose: generates a random vector of AUTH_VECTOR_LEN octets.
+ *
+ * Returns: the vector (call by reference)
+ *
+ */
+
+static void rc_random_vector (unsigned char *vector)
+{
+	int             randno;
+	int             i;
+	int		fd;
+
+/* well, I added this to increase the security for user passwords.
+   we use /dev/urandom here, as /dev/random might block and we don't
+   need that much randomness. BTW, great idea, Ted!     -lf, 03/18/95	*/
+
+	if ((fd = open(_PATH_DEV_URANDOM, O_RDONLY)) >= 0)
+	{
+		unsigned char *pos;
+		int readcount;
+
+		i = AUTH_VECTOR_LEN;
+		pos = vector;
+		while (i > 0)
+		{
+			readcount = read(fd, (char *)pos, i);
+			pos += readcount;
+			i -= readcount;
+		}
+
+		close(fd);
+		return;
+	} /* else fall through */
+
+	for (i = 0; i < AUTH_VECTOR_LEN;)
+	{
+		randno = magic();
+		memcpy ((char *) vector, (char *) &randno, sizeof (int));
+		vector += sizeof (int);
+		i += sizeof (int);
+	}
+
+	return;
+}
